(in-package :formulate-user)

(define-formulated-variable *x* 5 
  :formulator-class simple-formulator-source)

(define-formulated-variable *y* (expt *x* 2))

(assert (= *x* 5))

(assert (= *y* 25))

(setf *x* 2)

(assert (= *y* 4))


(defgeneric area (shape))
(defgeneric perimeter (shape))

(defclass square ()
  ((side :initarg side :accessor square-side)
   (perimeter formula-p t :initform (* (my 'side) 2) :reader perimeter)
   (area formula-p t :initform (expt (my 'side) 2) :reader area))
  (:metaclass formulated-class))

(defclass circle ()
  ((radius :initarg radius :accessor circle-radius)
   (perimeter formula-p t :initform (* (my 'radius) 2 pi) :reader perimeter)
   (area formula-p t :initform (* (expt (my 'radius) 2) pi) :reader area))
  (:metaclass formulated-class))

(let ((square (make-instance 'square)))
  (dotimes (i 5)
    (setf (square-side square) i)
    (format t "~&A square with side ~A has perimeter ~A and area ~A~%"
            (square-side square) (perimeter square) (area square))))

(let ((circle (make-instance 'circle)))
  (dotimes (i 5)
    (setf (circle-radius circle) i)
    (format t "~&A circle with radius ~A has perimeter ~A and area ~A~%"
            (circle-radius circle) (perimeter circle) (area circle))))
