(defpackage :formulate.clim-ui
  (:export #:formulate)
  (:use :clim-lisp :formulate :clim))

(in-package :formulate.clim-ui)


(define-application-frame formulate ()
  ()
  (:panes (interactor :interactor
                      :scroll-bars t))
  (:pointer-documentation t)
  (:layouts (default
              interactor)))

(define-formulate-command (com-define-formulated-variable :name "Define Formulated Variable")
  ((name 'symbol) (formula 'expression)
   (declarations 'expression :default '())
   (documentation '(or string null) :default nil))
  (funcall (compile nil (lambda () `(define-formulated-variable ,name ,formula
                                      :declare ,declarations :documentation ,documentation)))))

(define-formulate-command (com-define-formulated-class :name "Define Formulated Class")
  ((name 'symbol) (superclasses '(sequence class) :default '()) (slots '(sequence slot-specification)))
  (eval `(defclass ,name ,(coerce superclasses 'list)
           (,@(coerce slots 'list))
           (:metaclass formulated-class))))

(define-presentation-type slot-specification ()
  :inherit-from 'expression)

(define-presentation-method accept ((type slot-specification) stream view &key default default-type)
  (let* ((name (if default
                   (accept 'symbol :prompt "Name" :default (first default))
                 (accept 'symbol :prompt "Name")))
         (formulated-p (accept 'boolean :prompt "Formulated?"
                               :default (getf default 'formulated-p t) :default-type 'boolean))
         (initform (accept 'expression :prompt (if formulated-p "Formula" "Initial value"))))
    `(,name formulated-p ,formulated-p :initform ,initform)))
