(in-package :formulate)

(defmacro define-formulated-variable (name formula
                                      &key declare
                                           documentation
                                           (formulator-class 'lazy-formula-formulator-sink)
                                           formulator-options)
  `(progn
     (define-symbol-macro ,name (formulate-variable ',name))
     (setf (documentation ',name 'variable) ,documentation)
     (setf (symbol-value ',name)
           (make-instance ',formulator-class
                          'formula ',formula
                          'formula-function (lambda () (declare ,@declare) ,formula)
                          ,@formulator-options))
     ',name))

(defun formulate-variable (name)
  (formulator-value (symbol-value name) 'unbound-variable name))

(defun (setf formulate-variable) (new-value name)
  (setf (formulator-value (symbol-value name)) new-value))
